import 'dart:convert';

class CoreAction {
  static const String _DESTROY = "destroy";
  static const String _TOPICS = "topics";
  static const String _TYPE = "type";
  static const String TYPE_APP = "app";
  static const String TYPE_URL = "url";
  static const String TYPE_CALL = "call";
  static const String TYPE_MARKET = "market";
  static const String TYPE_SHARE = "share";
  static const String TYPE_NO_ACTION = "no_action";
  static const String TYPE_WALLET = "wallet";

  static const String ACTION = "action";

  bool destroy = true;
  List<String>? topics;
  Type? type;
  String? app;
  String? url;
  String? call;
  String? market;
  String? share;
  String? no_action;
  String? wallet;

  /// Constructor of CoreAction
  CoreAction(Map map) {
    map.forEach((key, value) {
      switch (key) {
        case _DESTROY:
          destroy = value.toString() == "true";
          break;
        case _TOPICS:
          topics = json.decode(value.toString());
          break;
        case _TYPE:
          type = getType(value.toString());
          break;
        case TYPE_APP:
          app = value.toString();
          break;
        case TYPE_URL:
          url = value.toString();
          break;
        case TYPE_CALL:
          call = value.toString();
          break;
        case TYPE_MARKET:
          market = value.toString();
          break;
        case TYPE_SHARE:
          share = value.toString();
          break;
        case TYPE_NO_ACTION:
          no_action = value.toString();
          break;
        case TYPE_WALLET:
          wallet = value.toString();
          break;
      }
    });
  }

  /// Convertion Model [CoreAction] to Map
  Map toMap() {
    Map map = Map();
    if (topics != null) map[_TOPICS] = topics;
    if (type != null) map[_TYPE] = type.toString();
    if (app != null) map[TYPE_APP] = app;
    if (url != null) map[TYPE_URL] = url;
    if (call != null) map[TYPE_CALL] = call;
    if (market != null) map[TYPE_MARKET] = market;
    if (share != null) map[TYPE_SHARE] = share;
    if (no_action != null) map[TYPE_NO_ACTION] = no_action;
    if (wallet != null) map[TYPE_WALLET] = wallet;
    return map;
  }
}

/// enum with action types
enum Type { APP, URL, CALL, MARKET, SHARE, NO_ACTION, WALLET }

/// get Type String
Type getType(String type) {
  Type value = Type.APP;
  switch (type) {
    case CoreAction.TYPE_APP:
      value = Type.APP;
      break;
    case CoreAction.TYPE_URL:
      value = Type.URL;
      break;
    case CoreAction.TYPE_CALL:
      value = Type.CALL;
      break;
    case CoreAction.TYPE_MARKET:
      value = Type.MARKET;
      break;
    case CoreAction.TYPE_SHARE:
      value = Type.SHARE;
      break;
    case CoreAction.TYPE_NO_ACTION:
      value = Type.NO_ACTION;
      break;
    case CoreAction.TYPE_WALLET:
      value = Type.WALLET;
      break;
  }
  return value;
}
