import 'dart:convert';

class ErrorModel {
  static const String MAP_ERROR_CODE = "code";
  static const String MAP_ERROR_MESSAGE = "messsage";

  String? errorCode;
  String? errorMessage;

  /// Constructor of Errormodel
  ///
  /// Using an errorCode and error message [String]
  ErrorModel(String? errorCode, String? errorMessage) {
    if (errorCode != null) this.errorCode = errorCode;
    if (errorMessage != null) this.errorMessage = errorMessage;
  }
  Map toMap() {
    Map map = Map();
    if (errorCode != null) map[MAP_ERROR_CODE] = errorCode;

    if (errorMessage != null) map[MAP_ERROR_MESSAGE] = errorMessage;
    return map;
  }

  /// To String conversion
  @override
  String toString() {
    return json.encode(toMap());
  }
}
