import 'dart:convert';
import 'dart:io';

import 'InAppAction.dart';

class InAppProperties {
  static const String PROPERTIES = "properties";

  static const String _ACTION = InAppAction.ACTION;
  static const String _CONTENT_URL = "contentUrl";
  static const String _SHOWTIME = "showTime";
  static const String _LAYOUT = "layout";

  InAppAction? action;
  String? contentUrl;
  int? showTime;
  //InAppLayout? layout;

  /// Constructor of InAppProperties
  InAppProperties(Map map) {
    map.forEach((key, value) {
      switch (key) {
        case _ACTION:
          if (Platform.isAndroid) {
            action = InAppAction(json.decode(value.toString()));
          } else {
            action = InAppAction(value);
          }
          break;
        case _CONTENT_URL:
          contentUrl = value.toString();
          break;
        case _SHOWTIME:
          showTime = int.parse(value.toString());
          break;
      }
    });
  }

  /// Conversion to Map
  Map toMap() {
    Map map = Map();
    if (action != null) map[_ACTION] = action!.toMap();
    if (contentUrl != null) map[_CONTENT_URL] = contentUrl;
    if (showTime != null) map[_SHOWTIME] = showTime;
    return map;
  }
}
