import 'dart:convert';

import 'package:indigitall_flutter_plugin/inbox/models/InboxNotification.dart';

class Inbox {
  static const LAST_ACCESS = "lastAccess";
  static const NOTIFICATIONS = InboxNotification.NOTIFICATIONS;
  static const COUNT = "count";
  static const PAGESIZE = "pageSize";
  static const PAGE = "numPage";

  List<InboxNotification>? notifications;

  String? lastAccess;
  int? count;
  int? pageSize;
  int? page;
  List<InboxNotification>? newNotifications;

  ///Constructor of Inbox
  ///
  /// param Map
  Inbox(Map map) {
    map.forEach((key, value) {
      switch (key) {
        case LAST_ACCESS:
          lastAccess = value.toString();
          break;
        case NOTIFICATIONS:
          String notificationsString = value.toString();
          notifications = InboxNotification.createArray(notificationsString);
          break;
        case COUNT:
          count = int.parse(value.toString());
          break;
        case PAGESIZE:
          pageSize = int.parse(value.toString());
          break;
        case PAGE:
          page = int.parse(value.toString());
          break;
      }
    });
  }

  /// conversion to Map
  Map toMap() {
    Map map = Map();
    if (lastAccess != null) map[LAST_ACCESS] = lastAccess;
    if (count != null) map[COUNT] = count;
    if (pageSize != null) map[PAGESIZE] = pageSize;
    if (page != null) map[PAGE] = page;
    if (notifications != null) {
      List<Map> list = [];
      for (var i = 0; i < notifications!.length; i++) {
        list.add(notifications![i].toMap());
      }
      map[NOTIFICATIONS] = list;
    }
    return map;
  }
}
